#include "Ellipse.h"
#include <iomanip> // to use the setprecision manipulator
 
/*********************************************
	Constructores
 *********************************************/

Ellipse::Ellipse() 
{
}

Ellipse::Ellipse(ifstream & infile) 
{
  infile >> sub_type;
  infile >> line_style;
  infile >> thickness;
  infile >> pen_color;
  infile >> fill_color;
  infile >> depth;
  infile >> pen_style;
  infile >> area_fill;
  infile >> style_val;
  infile >> direction;
  infile >> angle;
  infile >> center_x;
  infile >> center_y;
  infile >> radius_x;
  infile >> radius_y;
  infile >> start_x;
  infile >> start_y;
  infile >> end_x;
  infile >> end_y;
}

/*********************************************
	Operaciones
 *********************************************/
void Ellipse::write(void)
{
  cout << '\n' << object_code << ' ' << sub_type 
       << ' ' << line_style << ' ' << thickness
       << ' ' << pen_color << ' ' << fill_color
       << ' ' << depth << ' ' << pen_style
       << ' ' << area_fill << ' ' << style_val << ' ' << direction
       << ' ' << angle << ' ' << center_x << ' ' << center_y 
       << ' ' << radius_x << ' ' << radius_y 
       << ' ' << start_x << ' ' << start_y 
       << ' ' << end_x << ' ' << end_y;
}

//-----------------------------------------------------

void Ellipse::mag(int x, int y, double f)
{
  thickness= int(thickness*f);
  center_x = x+int((center_x-x)*f);
  center_y = y+int((center_y-y)*f);
  radius_x= int(radius_x*f);
  radius_y= int(radius_y*f);
  start_x = x+int((start_x-x)*f);
  start_y = y+int((start_y-y)*f);
  end_x = x+int((end_x-x)*f);
  end_y = y+int((end_y-y)*f);
}

//-----------------------------------------------------

void Ellipse::trans(int x, int y)
{
  center_x += x;
  center_y += y;
  start_x += x;
  start_y += y;
  end_x += x;
  end_y += y;
}

//-----------------------------------------------------

void Ellipse::rot(int x_, int y_, char s)
{ double temp;
  center_x=center_x-x_;
  center_y=y_-center_y;
 
  if(s=='F') // caso a favor de los punteros del reloj
    {
        center_x = center_x*-1;
    }
  if(s=='C')  // caso en contra de los punteros del reloj
    {
       	center_y = center_y*-1;
    }
 temp=center_x;
 center_x=center_y;
 center_y=(int)temp;
 center_x=center_x+x_;
 center_y=y_-center_y;

 if(angle==0.0000)
   {angle=1.5708;
    }
 if(angle==1.5708)
   {angle=0.0000;
    }


}

